Add dsa-wrap-nagios-check
authorPeter Palfrader <peter@palfrader.org>
Mon, 20 Mar 2017 08:43:40 +0000 (09:43 +0100)
committerPeter Palfrader <peter@palfrader.org>
Mon, 20 Mar 2017 08:43:40 +0000 (09:43 +0100)
dsa-nagios-checks/debian/changelog
dsa-nagios-checks/sbin/dsa-wrap-nagios-check [new file with mode: 0755]

index d04c057..6e8749d 100644 (file)
@@ -10,6 +10,7 @@ dsa-nagios-checks (110) UNRELEASED; urgency=medium
   * dsa-check_puppet_agent: add from Alexander Swen's github.
   * dsa-check-memory: move from / to /checks in source (so now it should get
     installed.)
+  * dsa-wrap-nagios-check: add.
 
  -- Peter Palfrader <weasel@debian.org>  Mon, 23 Jan 2017 14:14:06 +0100
 
diff --git a/dsa-nagios-checks/sbin/dsa-wrap-nagios-check b/dsa-nagios-checks/sbin/dsa-wrap-nagios-check
new file mode 100755 (executable)
index 0000000..987eab5
--- /dev/null
@@ -0,0 +1,90 @@
+#!/bin/sh
+
+# Copyright 2017 Peter Palfrader
+#
+# Permission is hereby granted, free of charge, to any person obtaining
+# a copy of this software and associated documentation files (the
+# "Software"), to deal in the Software without restriction, including
+# without limitation the rights to use, copy, modify, merge, publish,
+# distribute, sublicense, and/or sell copies of the Software, and to
+# permit persons to whom the Software is furnished to do so, subject to
+# the following conditions:
+#
+# The above copyright notice and this permission notice shall be
+# included in all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+
+# wrap a nagios check and write a status-file to be used with dsa-check-statusfile
+
+set -u
+
+STATUSDIR=/var/cache/dsa/nagios
+
+usage(){
+  ret=$1
+
+  cat <<EOF
+$0: usage:
+  $0 <options> <nagios-check> [nagios-check-options]
+
+  Calls nagios-check and stores its result in a state
+  file in status-dir.  The state file is named after
+  the nagios check (but can be overridden with -s).
+
+  -s <dir>      state dir ($STATUSDIR)
+  -s <filename> state file name
+  -h            print this help
+EOF
+
+  exit $ret
+}
+
+
+while getopts S:s:h opt ; do
+  case "$opt" in
+    S) STATUSDIR="$OPTARG" ;;
+    s) STATUSFILE="$OPTARG";;
+    h) usage 0 ;;
+    ?) usage 1 ;;
+  esac
+done
+shift $(($OPTIND - 1))
+if [ "$#" = 0 ]; then
+  usage 1 >&2
+fi
+
+if [ -z "${STATUSFILE:-}" ]; then
+  STATUSFILE="$(basename "$1")"
+fi
+
+if ! [ -d "$STATUSDIR" ]; then
+  echo >&2 "status directory $STATUSDIR does not exist."
+  exit 3
+fi
+
+tmp=`tempfile`
+trap "rm -f '$tmp'" exit
+"$@" > "$tmp" 2>&1
+result="$?"
+case "$result" in
+  0)
+    st="OK"
+    ;;
+  1)
+    st="WARNING"
+    ;;
+  2)
+    st="CRITICAL"
+    ;;
+  *)
+    st="UNKNOWN"
+    ;;
+esac
+(echo "$st"; cat "$tmp") > "$STATUSDIR/$STATUSFILE"